#!/usr/bin/python2.7
'''
Created on 2018/6/5
@author: jtao
'''
import sys
import getopt
def readpos(filename,poslist,sitname):
    try:
        fid = open(filename,"r")
    except:
        print "ERROR(readpos): no such file %s"%(filename)
        return -1
    for line in fid:
        value = line.split()
        name = value[6]
        #name = re.findall(r"[1-9]*[A-Za-z]+[1-9]*",line,0)
        if len(name) < 1:
            print "***ERROR(rdPosFile) Wrong Fmt: %s"%(line)
            return -1
        data = [value[7],value[8],value[9]]
        if name not in sitname:
            sitname.append(name)
            posSer = [0,0,0]
            poslist.append(posSer)
            ind = sitname.index(name)
        else:
            ind = sitname.index(name) 
        poslist[ind][0] = float(data[0]) 
        poslist[ind][1] = float(data[1])  
        poslist[ind][2] = float(data[2]) 
    fid.close()
    return 0;
def readxyz(filename,poslist,sitname):
    try:
        fid = open(filename,"r")
    except:
        print "ERROR(readpos): no such file %s"%(filename)
        return -1
    for line in fid:
        value = line.split()
        name = value[0]
        #name = re.findall(r"[1-9]*[A-Za-z]+[1-9]*",line,0)
        if len(name) < 1:
            print "***ERROR(rdPosFile) Wrong Fmt: %s"%(line)
            return -1
        data = [value[1],value[2],value[3]]
        if name not in sitname:
            sitname.append(name)
            posSer = [0,0,0]
            poslist.append(posSer)
            ind = sitname.index(name)
        else:
            ind = sitname.index(name) 
        poslist[ind][0] = float(data[0]) 
        poslist[ind][1] = float(data[1])  
        poslist[ind][2] = float(data[2]) 
    fid.close()
    return 0
if __name__ == '__main__':
    usage = "Usage pos2sit.py -p posfile -s sitfile --fxyz xyz_file -h"
    poslist = []
    sitname = []
    posfile = ""
    sitfile = ""
    xyzfile = ""
    opts,args = getopt.getopt(sys.argv[1:], "hs:p:",['fxyz='])
    if len(opts) == 0:
        print usage
        sys.exit()
    for op,value in opts:
        if op == '-h':
            print usage
            sys.exit()
        elif op == '-p':
            posfile = value
        elif op == '-s':
            sitfile = value
        elif op == '--fxyz':
            xyzfile = value
        else:
            print usage
            sys.exit()
    if posfile != "" and -1 == readpos(posfile,poslist,sitname):
        sys.exit()
    if xyzfile != "" and -1 == readxyz(xyzfile,poslist,sitname):
        sys.exit()    
    try:
        fid = open(sitfile,"r")
        fid_w = open("%s_tmp"%sitfile,"w")
    except:
        print "ERROR(readpos): no such file %s"%(sitfile)
        sys.exit()
        
    for line in fid:
        if line[0] != ' ':
            fid_w.write(line)
            continue
        name = line[1:5]
        if line[6:9] == "POS":
            for isit in xrange(len(sitname)):
                if sitname[isit].upper() == name.upper():
                    line = " %4s_POS%14.4lf%14.4lf%14.4lf%9.4lf%9.4lf%9.4lf%9.4lf%9.4lf%9.4lf%9.4lf%9.4lf%9.4lf\r\n"%(name,\
                       poslist[isit][0],poslist[isit][1],\
                       poslist[isit][2],0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0)
        fid_w.write(line)
    fid_w.close()
    pass
