#!/usr/local/bin/python3


import sys
import json
import os
def is_number(s): 
    try:
        float(s)
        return True
    except ValueError:
        pass
 
    try:
        import unicodedata
        unicodedata.numeric(s)
        return True
    except (TypeError, ValueError):
        pass
 
    return False

if __name__  == '__main__':
    message='命令错误'
    if len(sys.argv)<=1 :
        print(message)
        sys.exit()
    jsonfile=sys.argv[1]
    print ("%s"%jsonfile)
    try:    
        f = open(jsonfile,'r') 
        fw = open("py_tmp","w")   
    except:
        print ("can't open file %s or py_tmp"%jsonfile)
    confjson=json.load(f)
    for i in range(len(sys.argv)):  
        if i==0 or i==1: 
            continue
        command=sys.argv[i]  
        keyvalues = command.split('=') 
        keys = keyvalues[0].strip()   
        value = ""
        for i in range(len(keyvalues)):
            if i==0:continue  
            if i==1:
                value=keyvalues[i].strip()  
                #value=keyvalues[i]
            else:
                value = value + '+' +keyvalues[i].strip()
                #value = value + '+' +keyvalues[i] 
        ss=value.split('+')                                 #按照加号分开  存储在ss中  存储形式为列表list
        
        list1=[]
        list2=[]
        list3=[]
        for i in range(len(ss)):
            if i==0:
                list1.append(ss[i])
            if i>0 and i<4:
                list2.append(ss[i])
            if i>3:
                list3.append(ss[i])
        value1=''   
        value2=''
        value3=''
        value1=list1[0]
        for j in range(len(list2)):   
            value2=value2+' '+list2[j]
        for k in range(len(list3)):   
            value3=value3+' '+list3[k]
        value=[]
        value.append(value1)
        value.append(value2)
        value.append(value3)   
                
        key_array=keys.split(':')    
        command_sum='confjson'      
        for j in range(len(key_array)):  
            key_array[j].strip()
            if(is_number(key_array[j])):
                command_sum = command_sum + "["+key_array[j]+"]"  
            else:
                command_sum = command_sum + "[\""+key_array[j]+"\"]" 
                  
        command_sum=command_sum + ".append(value)"
        
        exec(command_sum)  
        pass
    js_str=json.dumps(confjson,sort_keys=True,indent=2) #将python对象编码为json字符串    #
    fw.write(js_str)  #先写入tmp文件中
    f.close()
    fw.close()
    cmd="mv py_tmp %s"%jsonfile  #将写入内容转移到控制文件中
    os.system(cmd)    #执行命令
    pass
